﻿package  {
    
    import flash.display.*;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.events.TimerEvent;
    import flash.filters.GlowFilter;
    import flash.text.TextField;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;
    import flash.utils.Timer;
    import net.hires.debug.Stats;
    
    /**
    * フィルタ処理を含めてのプリレンダリング.
    * @author kawakita
    * @version 0.1
    */
    public class PrerenderingWithFilter extends MovieClip{
        
        //------- CONST ------------------------------------------------------------------------
        //------- MEMBER -----------------------------------------------------------------------
        private var _stats:Stats;
        private var _sp:Sprite;
        
        //------- PUBLIC -----------------------------------------------------------------------
        
        /** コンストラクタ. */
        public function PrerenderingWithFilter() {
            
            stage.align = StageAlign.TOP_LEFT;
            stage.showDefaultContextMenu = false;
            
            _sp = new Sprite();
            addChild( _sp );
            _sp.mouseChildren = false;
            _sp.mouseEnabled = false;
            
            var startBtn:SimpleButton = new ClickToStart();
            startBtn.x = ( stage.stageWidth - startBtn.width ) / 2;
            startBtn.y = ( stage.stageHeight - startBtn.height ) / 2;
            startBtn.addEventListener(MouseEvent.CLICK, _onClick );
            addChild( startBtn )
            
            _stats = new Stats();
            addChild( _stats );
            
        }
        
        //------- PRIVATE ----------------------------------------------------------------------
        private function _onClick(e:MouseEvent):void {
            removeChild( e.target as DisplayObject );
            e.target.removeEventListener(MouseEvent.CLICK, _onClick );
            var timer:Timer = new Timer(1000, 1);
            timer.addEventListener(TimerEvent.TIMER_COMPLETE, function(e){
                for ( var i:uint = 0; i < 200; i++ ) _sp.addChild( new Graphic6() );
                var timer2:Timer = new Timer(30000, 1);
                timer2.addEventListener(TimerEvent.TIMER_COMPLETE, function(e) {
                    Graphic6.stop();
                });
                timer2.start();
            });
            timer.start();
        }
        
        //------- PROTECTED --------------------------------------------------------------------
        //------- INTERNAL ---------------------------------------------------------------------
    
    }
    
}